package gui.settings.dialog.component;

import gui.settings.dialog.component.SingleSettingsComponent;

import java.awt.Component;

import javax.swing.DefaultListModel;
import javax.swing.JList;
import javax.swing.JScrollPane;

public abstract class AbstractListSettingsComponent<V> extends SingleSettingsComponent{

	protected DefaultListModel<V> listValsModel;
	protected JScrollPane scroll;
	protected JList<V>  listVals;
	
	public AbstractListSettingsComponent(String settingsName) {
		super(settingsName);
		listValsModel = new DefaultListModel<>();
		listVals = new JList<>(listValsModel);
		scroll=new JScrollPane(listVals);
	}

	public void valueUp() {
		int index=listVals.getSelectedIndex();
		
		if (index>0) {
			V swap=listValsModel.get(index);
			int indexMinus1=index-1;
			listValsModel.set(index, listValsModel.get(indexMinus1));
			listValsModel.set(indexMinus1, swap);
			listVals.setSelectedIndex(indexMinus1);
			listVals.ensureIndexIsVisible(indexMinus1);
		}
	}
	
	public void valueDown(){
		int index=listVals.getSelectedIndex();
		
		if (index<listValsModel.getSize()-1) {
			V swap=listValsModel.get(index);
			int indexPlus1=index+1;
			listValsModel.set(index, listValsModel.get(indexPlus1));
			listValsModel.set(indexPlus1, swap);
			listVals.setSelectedIndex(indexPlus1);
			listVals.ensureIndexIsVisible(indexPlus1);
		}
	}
	
	public void removeSelected() {
		int index=listVals.getSelectedIndex();
		if (index>-1)
			listValsModel.remove(index);
	}
	
	public void addValue(V v){
		listValsModel.addElement(v);
	}

	@Override
	public Component getComponent() {
		return scroll;
	} 
	
}